#Requires
require 'rubygems'
require 'gratr/import'

#Require de mis clases
require 'paises.rb'
require 'funciones.rb'

def firmar_primer_bt(grafo,paises,paises_activos,bp,p)
  firmado=false
  begin
	  c=0
          rand(0)
          prob=rand(0)
          rand (0)
          if (prob<bp)
            begin
              segundo_nodo = elegir_nodo_PA(paises_activos, paises, grafo)
	      if (paises[p].des!=paises[segundo_nodo].des and prob<=bp)
		 grafo.add_edge!(p,segundo_nodo)
		 firmado = true
	      end
              c = c+1
            end until(firmado or c>5)
          else
            begin
              segundo_nodo = elegir_nodo_PA(paises_activos, paises, grafo)
	      if (paises[p].des==paises[segundo_nodo].des)
		 grafo.add_edge!(p,segundo_nodo)
		 firmado = true
	      end
              c = c+1
            end until(firmado or c>5)
          end	    
  end  until firmado
end


def firmar_bt_bip(grafo,paises,paises_activos,bp,rp)
  firmado=false
    rand(0)
    rand_prob=rand(0)
    rand(0)
    rand(0)
    rand(0)
    bip_prob=rand(0)
    rand(0)
    c = 0
    if(rand_prob<=rp)
       if(bip_prob>bp)
             cant_paises_activos = paises_activos.size
             primer_nodo = paises_activos[rand(cant_paises_activos)]
             segundo_nodo = paises_activos[rand(cant_paises_activos)]	
             if (paises[primer_nodo].des==paises[segundo_nodo].des and  primer_nodo != segundo_nodo and not grafo.edge?(primer_nodo,segundo_nodo))			
                firmado = true 
                grafo.add_edge!(primer_nodo,segundo_nodo)
             end

      else
             cant_paises_activos = paises_activos.size
             primer_nodo = paises_activos[rand(cant_paises_activos)]
             segundo_nodo = paises_activos[rand(cant_paises_activos)]	
             if (paises[primer_nodo].des!=paises[segundo_nodo].des and  primer_nodo != segundo_nodo and not grafo.edge?(primer_nodo,segundo_nodo))			
                firmado = true 
                grafo.add_edge!(primer_nodo,segundo_nodo)
             end
             c = c+1
      end

   else
        if(bip_prob>bp)
             cant_paises_activos = paises_activos.size
             primer_nodo = elegir_nodo_fitness(paises_activos, paises, grafo)
             segundo_nodo = elegir_nodo_PA_fitness(paises_activos, paises, grafo)	
             if (paises[primer_nodo].des==paises[segundo_nodo].des and  primer_nodo != segundo_nodo and not grafo.edge?(primer_nodo,segundo_nodo))			
                firmado = true 
                grafo.add_edge!(primer_nodo,segundo_nodo)
             end
             c = c+1
      else
             primer_nodo = elegir_nodo_fitness(paises_activos, paises, grafo)
             segundo_nodo = elegir_nodo_PA_fitness(paises_activos, paises, grafo)
             if (paises[primer_nodo].des!=paises[segundo_nodo].des and  primer_nodo != segundo_nodo and not grafo.edge?(primer_nodo,segundo_nodo))			
                firmado = true 
                grafo.add_edge!(primer_nodo,segundo_nodo)
             end
             c = c+1
      end

   end
end


def firmar_bt_no_bip(grafo,paises,paises_activos,rand_prob)
  firmado=false
  r = rand(0)
  cant_paises_activos = paises_activos.size
    if(rand_prob<=r)
      begin
        primer_nodo = paises_activos[rand(cant_paises_activos)]
        segundo_nodo = paises_activos[rand(cant_paises_activos)]				
        firmado = true unless ( primer_nodo == segundo_nodo or grafo.edge?(primer_nodo,segundo_nodo) )
      end until(firmado)
      grafo.add_edge!(primer_nodo,segundo_nodo)
    else
       begin
         rand(0)
         rf1 = rand(0)
         rand(0)
	 rf2 = rand(0)
         #puts rf1
         #puts rf2
   	 primer_nodo = elegir_nodo_fitness(paises_activos, paises, grafo) 
         segundo_nodo = elegir_nodo_PA_fitness(paises_activos, paises, grafo)
	 firmado = true	unless ( primer_nodo == segundo_nodo or grafo.edge?(primer_nodo,segundo_nodo) )
       end until(firmado)
       grafo.add_edge!(primer_nodo,segundo_nodo)
    end
end


def algoritmo(lambda,rp1, bip1,rp2,bip2,rp3,bip3)
        bip1 = bip1 * 0.01
        bip2 = bip2 * 0.01
        bip3 = bip3 * 0.01
        
        rp1 = rp1 * 0.01
        rp2 = rp2 * 0.01
        rp3 = rp3 * 0.01

        bits_ori =[5,11,20,27,36,49,57,62,67,72,77,82,88,97,109,115,130,140,157,166,181,193,209,224,243,268,289,312,344,386,446,527,651,779,964,1162,1364,1528,1693,1814,1945,2116,2236,2324,2397,2460]

        err_min = 0

        dir = "#{lambda}-#{rp1}-#{bip1}-#{rp2}-#{bip2}-#{rp3}-#{bip3}"
        #Dir.mkdir(dir)
        
        
	acum=[]
        0.upto(46)do |i|
          acum[i]=0
        end

	1.upto(15) do |arch|
             # puts arch
                ###Parseo el archivo de paises y me armo un diccionario###
		f_paises = File.new("datos/datos_paises.txt").readlines
		paises = armar_dict_paises(f_paises,lambda)
	
		### Parseo el archivo de anho_inicio y agrego la info a los paises ###
		f_ano_in = File.new("datos/anho_inicio.txt").readlines
		ano_inicio = armar_dict_anos(f_ano_in,paises)
	
		### Parseo anhos-cantBT###
		f_cant_bt = File.new("datos/cant_bt_por_ano_0.039.txt").readlines
		cant_bt_por_ano = armar_dict_cant_bt(f_cant_bt)

                #f_name="#{dir}/modelo_"+arch.to_s+".edgelist"
	        #f = File.new(f_name, "w+")
		#Creo el grafo y la lista de paises activos:
		grafo = UndirectedGraph.new()
		paises_activos = []
		
		acum_bt=0
		
		#El primer anho lo trato aparte
		ano_inicio[1959].each do |p|
			grafo.add_vertex!(p) 
			paises_activos << p
	        end
		
		grafo.add_edge!(paises_activos[1],paises_activos[0],1959)
	        v = []
	       #1960
	          #selecciono dos nodos random, los hago firmar entre ellos y despues agrego el resto
	          k=ano_inicio[1960].size
	          rand1=rand(k)
	          begin rand2=rand(k) end until (rand2 != rand1)
	         
	          r1=ano_inicio[1960][rand1]
	          r2 = ano_inicio[1960][rand2]
	          
	          
	          grafo.add_vertex!(r1)
	          paises_activos << r1
	          grafo.add_vertex!(r2)
	          paises_activos << r2
	          grafo.add_edge!(r1,r2,1960)
	           
	         ano_inicio[1960].each do |p|
	               unless(grafo.vertex?(p))
				grafo.add_vertex!(p) 
				  firmar_primer_bt(grafo,paises,paises_activos,bip1,p)
		   		  paises_activos << p
	                end
                 #puts "1960:  #{grafo.edges.size}"
		end 
                v.push(grafo.edges.size)
	
	      #1961
	         #selecciono dos nodos random, los hago firmar entre ellos y despues agrego el resto
	          rand1=rand(ano_inicio[1961].size)
	          begin rand2=rand(ano_inicio[1961].size) end until (rand2 != rand1)
	         
	          r1=ano_inicio[1961][rand1]
	          r2 = ano_inicio[1961][rand2]
	          
	          grafo.add_vertex!(r1)
	          paises_activos << r1
	          grafo.add_vertex!(r2)
	          paises_activos << r2
	          grafo.add_edge!(r1,r2,1961)
	
	         ano_inicio[1961].each do |p|
	               if (p != r1 && p != r2)
				grafo.add_vertex!(p) 
			        firmar_primer_bt(grafo,paises,paises_activos,bip1,p)
				paises_activos << p
	                end
                 #puts "1961:  #{grafo.edges.size}"
		end 
                v.push(grafo.edges.size)
                k=2
                err = 0
 		1962.upto(1975) do |a|
                       #puts a
         	       #Agrego los nodos de ese ano y los paises activos, y a cada nodo nuevo lo hago firmar un BT
			unless ano_inicio[a].nil?
				ano_inicio[a].each do |p|
					grafo.add_vertex!(p) 
		                        firmado=false
					firmar_primer_bt(grafo,paises,paises_activos,bip1,p)
                                        paises_activos << p
				end 
			end 
	
		
	        
			(ano_inicio[a].nil?) ? bts = cant_bt_por_ano[a] : bts = cant_bt_por_ano[a]-ano_inicio[a].size()
	
			acum_bt+=bts
			cant_paises_activos = paises_activos.size
	
			1.upto(bts) do
                           firmar_bt_bip(grafo,paises,paises_activos,bip1,rp1)
		        end
                       # puts "#{a}:  #{grafo.edges.size}"
                        v.push(grafo.edges.size)
                 
		end

		1976.upto(1989) do |a|
                     # puts a
         	       #Agrego los nodos de ese ano y los paises activos, y a cada nodo nuevo lo hago firmar un BT
			unless ano_inicio[a].nil?
				ano_inicio[a].each do |p|
					grafo.add_vertex!(p) 
		                        firmado=false
					firmar_primer_bt(grafo,paises,paises_activos,bip2,p)
                                        paises_activos << p
				end 
			end 
	
		
	        
			(ano_inicio[a].nil?) ? bts = cant_bt_por_ano[a] : bts = cant_bt_por_ano[a]-ano_inicio[a].size()
	
			acum_bt+=bts
			cant_paises_activos = paises_activos.size
	
			1.upto(bts) do
                           firmar_bt_bip(grafo,paises,paises_activos,bip2,rp2)
		        end
                        #puts "#{a}:  #{grafo.edges.size}"
                        v.push(grafo.edges.size)
                        #err = err + (grafo.edges.size - bits_ori[k])^2
                        #puts "#{err}"
                        #k = k+1
		end

	        1990.upto(2005) do |a|
                       #puts a
         	       #Agrego los nodos de ese ano y los paises activos, y a cada nodo nuevo lo hago firmar un BT
			unless ano_inicio[a].nil?
				ano_inicio[a].each do |p|
					grafo.add_vertex!(p) 
		                        firmado=false
					firmar_primer_bt(grafo,paises,paises_activos,bip3,p)
                                        paises_activos << p
				end 
			end 
	
		
	        
			(ano_inicio[a].nil?) ? bts = cant_bt_por_ano[a] : bts = cant_bt_por_ano[a]-ano_inicio[a].size()
	
			acum_bt+=bts
			cant_paises_activos = paises_activos.size
	
			1.upto(bts) do
                           firmar_bt_bip(grafo,paises,paises_activos,bip3,rp3)
		        end
                       #puts "#{a}:  #{grafo.edges.size}"
                       v.push(grafo.edges.size)
                       #err = err + (grafo.edges.size - bits_ori[k])^2
                       #puts "#{err}"
                       #k = k+1
		end
	        #puts v.inspect
	       # grafo.edges.each{ |e| f.puts e[0].to_s + ' ' + e[1].to_s}

               0.upto(bits_ori.length()-1) do |i|
                 acum[i] = acum[i] + v[i]
               end
	
	end
        0.upto(bits_ori.length()-1) do |i|
           acum[i] = acum[i]/15.0
           #puts "#{acum[i]}"
        end
        
        err=0
        0.upto(bits_ori.length()-1) do |i|
           #puts "#{bits_ori[i]} #{acum[i]}"
           err = (acum[i]-bits_ori[i])*(acum[i]-bits_ori[i]) + err
        end
       
        puts rp1.to_s + " "+ bip1.to_s + " "+rp2.to_s + " "+ bip2.to_s + " "+rp3.to_s + " "+ bip3.to_s + " " +err.to_s + " "+ acum.inspect()
        #if (err < err_min) 
         #       puts rp1.to_s + " "+ bip1.to_s + rp2.to_s + " "+ bip2.to_s + rp3.to_s + " "+ bip3.to_s + " " +err.to_s + " "+ acum.inspect()
          #      err_min = err
                #puts err_min 
        #end
end


1.step(1,1) do |lambda|
 2.step(10,5) do |r1|
  98.step(98,4) do |bip1|
    0.step(8,4) do |r2|
     98.step(98,5) do |bip2|
      2.step(6,2) do |r3|
      50.step(60,5) do|bip3|
        algoritmo(lambda,r1,bip1,r2,bip2,r3,bip3)
      end
    end
   end
  end
  end 
  end
end


