#Requires
require 'rubygems'
require 'gratr/import'

#Require de mis clases
require 'paises.rb'
require 'funciones.rb'
require 'modif_clase_grafos'

###Parseo el archivo de paises y me armo un diccionario###
f_paises = File.new("datos/datos_paises.txt").readlines
paises = armar_dict_paises(f_paises)

### Armo el grafo original ###
grafo_original = UndirectedGraph.new()
grafo_original = armar_grafo_original_hasta(paises,"datos/bts_originales.txt",2005)


puts "grado maximo: " + grafo_original.max_degree.to_s
puts "grado minimo: " + grafo_original.min_degree.to_s
puts "cantidad de ejes: " + grafo_original.edges.length.to_s

puts "Grados: "
grafo_original.each { |n| puts n + ': ' + grafo_original.degree(n).to_s}

#v=grafo_original.vertices[1]
#e=grafo_original.encontrar_competidores(v)
#puts e

random=0
grafo_original.each do |p|
   if grafo_original.degree(p)<20
       grafo_original.adjacent(p).each do |p2|
         if grafo_original.degree(p2)<20 
            random = random + 1 
            puts p + ' ' + p2
         end
       end 
   end
end

puts "BTS RANDOM " + (random/2).to_s