#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
A simple example to create a graphviz dot file and draw a graph.

"""
#    Copyright (C) 2006 by 
#    Aric Hagberg <hagberg@lanl.gov>
#    Dan Schult <dschult@colgate.edu>
#    Manos Renieris, http://www.cs.brown.edu/~er/
#    Distributed with BSD license.     
#    All rights reserved, see LICENSE for details.
__author__ = """Aric Hagberg (hagberg@lanl.gov)"""

from networkx import *
                      
from math import *
from pygraphviz import *



#BT=read_edgelist("BN.edgelist")
#print BT.degree(with_labels='True')


print "***************************"
print "*** BTs  RAND - RAND   ****"
print "***************************"

ejes=0
clique_num=0
coef_clust= 0
diam= 0
rad = 0
l_tot = 0
grados = {}

na="modelo_1.edgelist"
BT=read_edgelist(na)

for n in BT:
  grados[n] = 0

maximo=2.0
print "cant_ejes clique_numb coef_clust diam rad l"
r=range(1,51)
for f in r:
   na="modelo_"+str(f)+".edgelist"
   BT=read_edgelist(na)
   #minimum of all pairs shortest path.
   if is_connected(BT):
	l=all_pairs_shortest_path_length(BT)
	nodes=nodes_iter(BT)
	p=0
	acum=0.0
	for i in nodes:
		for j in nodes:
	          if (i != j):
     			p=p+l[i][j]
			acum=acum+1.0
        p=p/acum
        l_tot=l_tot+p
   else:
	p="NC"
   
   
   ejes=BT.number_of_edges()
   clique_num=graph_clique_number(BT)
   coef_clust= average_clustering(BT)
   diam= diameter(BT)
   rad = radius(BT)
   print str(f) +" "+ str(clique_num)+ " " + str(coef_clust)+  " " + str(diam)+" "+ str(rad) + " "+ str(p)


