#Requires
require 'rubygems'
require 'gratr/import'

#Require de mis clases
require 'paises.rb'
require 'funciones.rb'



###Parseo el archivo de paises y me armo un diccionario###
f_paises = File.new("datos/datos_paises.txt").readlines
paises = armar_dict_paises(f_paises)
#f_paises.close

### Parseo el archivo de anho_inicio y agrego la info a los paises ###
f_ano_in = File.new("datos/anho_inicio.txt").readlines
ano_inicio = armar_dict_anos(f_ano_in,paises)
#f_anho_in.close

### Parseo anhos-cantBT###
f_cant_bt = File.new("datos/cant_bt_por_ano.txt").readlines
cant_bt_por_ano = armar_dict_cant_bt(f_cant_bt)

#Creo el grafo y la lista de paises activos:
grafo = UndirectedGraph.new()
paises_activos = []

acum_bt=0
1959.upto(1999) do |a|

  #Agrego los nodos de ese ano y los paises activos
  ano_inicio[a].each do |p|
    grafo.add_vertex!(paises[p], p) 
    paises_activos << p
  end unless ano_inicio[a].nil?
   
  bts = cant_bt_por_ano[a]
  cant_paises_activos = paises_activos.length
 # puts cant_paises_activos
  acum_bt+=bts

  1.upto(bts) do
    begin
      primer_nodo = paises_activos[rand(cant_paises_activos)]
      segundo_nodo = paises_activos[rand(cant_paises_activos)]
    end while (primer_nodo == segundo_nodo or grafo.edge?(primer_nodo,segundo_nodo) )

    grafo.add_edge!(primer_nodo,segundo_nodo, a)
   
  end

end



#puts paises_activos.inspect
#puts grafo.inspect
acum=0
grafo.each do |n|  
  puts grafo.degree(n) 
  acum+=grafo.degree(n)
end

puts acum_bt
puts acum


