#Requires
require 'rubygems'
require 'gratr/import'
require 'random/mersenne_twister'
     

#Require de mis clases
require 'paises.rb'
require 'funciones.rb'

def firmar_bt(grafo,paises,paises_activos,r,rand_prob)
  firmado=false
  cant_paises_activos = paises_activos.size
    if(rand_prob<=r)
      begin
        primer_nodo = paises_activos[rand(cant_paises_activos)]
        segundo_nodo = paises_activos[rand(cant_paises_activos)]				
        firmado = true unless ( primer_nodo == segundo_nodo or grafo.edge?(primer_nodo,segundo_nodo) )
      end until(firmado)
      grafo.add_edge!(primer_nodo,segundo_nodo)
    else
       begin
         rand(0)
         rf1 = rand(0)
         rand(0)
	 rf2 = rand(0)
         #puts rf1
         #puts rf2
   	 primer_nodo = elegir_nodo_PA(paises_activos, paises, grafo) 
         segundo_nodo = elegir_nodo_PA_fitness(paises_activos, paises, grafo,rf2)
	 firmado = true	unless ( primer_nodo == segundo_nodo or grafo.edge?(primer_nodo,segundo_nodo) )
       end until(firmado)
       grafo.add_edge!(primer_nodo,segundo_nodo)
    end
end




def algoritmo(lambda,rp)
        rp=rp/100.0
        dir = "#{lambda}-#{rp}"
        Dir.mkdir(dir)
        srand()
        puts lambda.to_s
        puts rp.to_s
	
	
	1.upto(20) do |arch|
		###Parseo el archivo de paises y me armo un diccionario###
		f_paises = File.new("datos/datos_paises.txt").readlines
		paises = armar_dict_paises(f_paises,lambda)
		#f_paises.close
	
		### Parseo el archivo de anho_inicio y agrego la info a los paises ###
		f_ano_in = File.new("datos/anho_inicio.txt").readlines
		ano_inicio = armar_dict_anos(f_ano_in,paises)
		#f_anho_in.close
	
		### Parseo anhos-cantBT###
		f_cant_bt = File.new("datos/cant_bt_por_ano.txt").readlines
		cant_bt_por_ano = armar_dict_cant_bt(f_cant_bt)

                f_name="#{dir}/modelo_"+arch.to_s+".edgelist"
	        f = File.new(f_name, "w+")
		#Creo el grafo y la lista de paises activos:
		grafo = UndirectedGraph.new()
		paises_activos = []
		
		acum_bt=0
		
		#El primer anho lo trato aparte
		ano_inicio[1959].each do |p|
			grafo.add_vertex!(p) 
			paises_activos << p
	        end
		
		grafo.add_edge!(paises_activos[1],paises_activos[0],1959)
	
	       #1960
	          #selecciono dos nodos random, los hago firmar entre ellos y despues agrego el resto
	          k=ano_inicio[1960].size
	          rand1=rand(k)
	          begin rand2=rand(k) end until (rand2 != rand1)
	         
	          r1=ano_inicio[1960][rand1]
	          r2 = ano_inicio[1960][rand2]
	          
	          
	          grafo.add_vertex!(r1)
	          paises_activos << r1
	          grafo.add_vertex!(r2)
	          paises_activos << r2
	          grafo.add_edge!(r1,r2,1960)
	           
	         ano_inicio[1960].each do |p|
	               unless(grafo.vertex?(p))
				grafo.add_vertex!(p) 
				segundo_nodo = elegir_nodo_PA(paises_activos, paises, grafo) 
				grafo.add_edge!(p,segundo_nodo, 1960)
				paises_activos << p
	                end
		end 
	
	      #1961
	         #selecciono dos nodos random, los hago firmar entre ellos y despues agrego el resto
	          rand1=rand(ano_inicio[1961].size)
	          begin rand2=rand(ano_inicio[1961].size) end until (rand2 != rand1)
	         
	          r1=ano_inicio[1961][rand1]
	          r2 = ano_inicio[1961][rand2]
	          
	          grafo.add_vertex!(r1)
	          paises_activos << r1
	          grafo.add_vertex!(r2)
	          paises_activos << r2
	          grafo.add_edge!(r1,r2,1961)
	
	         ano_inicio[1961].each do |p|
	               if (p != r1 && p != r2)
				grafo.add_vertex!(p) 
                                rr = rand(0)
				segundo_nodo = elegir_nodo_PA_fitness(paises_activos, paises, grafo,rr)
				grafo.add_edge!(p,segundo_nodo, 1961)
				paises_activos << p
	                end
		end 

	       1962.upto(2005) do |a|
                        #puts 
			#Agrego los nodos de ese ano y los paises activos, y a cada nodo nuevo lo hago firmar un BT
			unless ano_inicio[a].nil?
				ano_inicio[a].each do |p|
					grafo.add_vertex!(p) 
		                        rr = rand(0)
					segundo_nodo = elegir_nodo_PA_fitness(paises_activos, paises, grafo,rr)
					grafo.add_edge!(p,segundo_nodo, a)
					paises_activos << p
			                #puts paises[p].fitness
				end 
			end 
	
		
	         
			(ano_inicio[a].nil?) ? bts = cant_bt_por_ano[a] : bts = cant_bt_por_ano[a]-ano_inicio[a].size()
	
			acum_bt+=bts
			cant_paises_activos = paises_activos.size
	
			1.upto(bts) do
                          rand(0)
		          rand_prob = rand(0)
                          rand(0)
                          #puts rand_prob
		          firmar_bt(grafo,paises,paises_activos,rp,rand_prob)
			end
	       end
	        grafo.edges.each{ |e| f.puts e[0].to_s + ' ' + e[1].to_s}
	
	end
end


1.step(1,1) do |lambda|
  #lambda = 0.1*lambda
  0.step(15,5) do |rand|
    algoritmo(lambda,rand)
 end
end
